## net.sf.saxon.type
Interface ItemType

All Known Subinterfaces:
  AtomicType

All Known Implementing Classes:
  AnyItemType, BuiltInAtomicType, ExternalObjectType, NodeTest

public interface ItemType

ItemType is an interface that allows testing of whether an Item conforms to an expected type. ItemType represents the types in the type hierarchy in the XPath model, as distinct from the schema model: an item type is either item() (matches everything), a node type (matches nodes), an atomic type (matches atomic values), or empty() (matches nothing). Atomic types, represented by the class AtomicType, are also instances of SimpleType in the schema type heirarchy. Node Types, represented by the class NodeTest, are also Patterns as used in XSLT.

See Also:
  `AtomicType`, `NodeTest`

Method Summary
`AtomicType` `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized
`ItemType` `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` `getPrimitiveType()` Get the primitive type corresponding to this item type.
`ItemType` `getSuperType()` Get the type from which this item type is derived by restriction.
`boolean` `matchesItem(Item item)` Test whether a given item conforms to this type
`java.lang.String` `toString(NamePool pool)` Produce a representation of this type name for use in error messages.

Method Detail

### matchesItem

    public boolean matchesItem(Item item)

  Test whether a given item conforms to this type

  Parameters:
    `item` - The item to be tested
  Returns:
    true if the item is an instance of this type; false otherwise

### getSuperType

    public ItemType getSuperType()

  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xdt:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  Returns:
    the supertype, or null if this type is item()

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

### getPrimitiveType

    public int getPrimitiveType()

  Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

### toString

    public java.lang.String toString(NamePool pool)

  Produce a representation of this type name for use in error messages. Where this is a QName, it will use conventional prefixes

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized